import sys, math, random, pygame

pygame.init()

screen=pygame.display.set_mode((640,480))

continueGame=True

shots=[]
enemies=[]
enemyShots=[]
totalEnemies=0
#totalEnemies=99

result=False

boss=0

class Visible:
    def behave(self):
        pass

    def getRect(self):
        rect=self.image.get_rect()
        rect=rect.move(self.posX,self.posY)
        return rect

    def draw(self):
        pass

class EnemyShot(Visible):
    def __init__(self,posX,posY):
        global enemyShots
        self.image=pygame.image.load("shot-red.png")
        self.posX=posX
        self.posY=posY
        enemyShots.append(self)

    def behave(self):
        self.posY+=2
        if self.posY>480:
            enemyShots.remove(self)
            return

    def draw(self):
        screen.blit(self.image,(self.posX,self.posY))

class Boss(Visible):
    def __init__(self):
        global enemies
        self.image=pygame.image.load("boss1.png")
        self.posX=150
        self.posY=-self.image.get_rect().height
        self.numHits=0
        self.lastShot=0
        enemies.append(self)

    def behave(self):
        global continueGame, result
        if self.posY<0:
            self.posY=self.posY+1
            return

        for shot in shots:
            if self.getRect().colliderect(shot.getRect()):
                self.numHits+=1
                shots.remove(shot)

        if self.numHits>50:
            continueGame=False
            result=True

        # TODO: let boss behave on its own
        if random.randint(0,100)<51:
            self.posX-=2
        else:
            self.posX+=2

        if self.posX<0:
            self.posX=0
        elif self.posX>640-self.image.get_rect().width:
            self.posX=640-self.image.get_rect().width

        self.lastShot-=1
        if self.lastShot>0:
            return
        
        if random.randint(0,100)<2:
            if random.randint(0,100)<50:
                self.lastShot=25
                EnemyShot(self.posX+38,self.posY+160)
                EnemyShot(self.posX+200,self.posY+160)
            else:
                if self.lastShot>-30:
                    return

                self.lastShot=25
                EnemyShot(self.posX+118,self.posY+220)

    def draw(self):
        screen.blit(self.image,(self.posX,self.posY))

class Enemy(Visible):
    def __init__(self):
        global enemies
        self.image=pygame.image.load("enemy1.png")

        validPosition=False
        while not validPosition:
            self.posX=random.randint(0,640-64)
            self.posY=-self.image.get_rect().height
            validPosition=True
            for enemy in enemies:
                if enemy.getRect().colliderect(self.getRect()):
                    validPosition=False
        
        enemies.append(self)

    def behave(self):
        self.posY+=2
        if self.posY>640:
            del enemies[enemies.index(self)]
            return

        for shot in shots:
            if self.getRect().colliderect(shot.getRect()):
                enemies.remove(self)
                shots.remove(shot)
                return
 
    def draw(self):
       screen.blit(self.image,(self.posX,self.posY))

class Shot(Visible):
    def __init__(self, posX):
        global shots
        self.image=pygame.image.load("shot-yellow.png")
        self.posX=posX
        self.posY=380
        shots.append(self)

    def behave(self):
        self.posY-=5
        if self.posY<-32:
            shots.remove(self)
            return

    def draw(self):
        screen.blit(self.image,(self.posX,self.posY))

class Player(Visible):
    def __init__(self):
        self.image=pygame.image.load("player.png")
        self.lastShot=0
        self.posX=320
    
    def moveLeft(self):
        self.posX-=2
        if self.posX<0:
            self.posX=0

    def moveRight(self):
        self.posX+=2
        if self.posX>640-64:
            self.posX=640-64

    def fire(self):
        if self.lastShot>0:
            return

        Shot(self.posX)
        Shot(self.posX+32)
        self.lastShot=20
        pass

    def getRect(self):
        rect=self.image.get_rect()
        rect=rect.move(self.posX,400)
        return rect

    def behave(self):
        global continueGame
        for enemy in enemies:
            if self.getRect().colliderect(enemy.getRect()):
                continueGame=False
                return

        for enemyShot in enemyShots:
            if self.getRect().colliderect(enemyShot.getRect()):
                continueGame=False
                return

    def draw(self):
        screen.blit(self.image,(self.posX,400))
        self.lastShot-=1
        pass

player=Player()

while continueGame:
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            continueGame=False
        elif event.type == pygame.KEYDOWN:
            if event.key == pygame.K_ESCAPE:
                continueGame=False
    
    if pygame.key.get_pressed()[pygame.K_LEFT]:
        player.moveLeft()
    if pygame.key.get_pressed()[pygame.K_RIGHT]:
        player.moveRight()
    if pygame.key.get_pressed()[pygame.K_SPACE]:
        player.fire()

    if totalEnemies < 100:
        if random.randint(0,1000)<20:
            Enemy()
            totalEnemies+=1
    else:
        if len(enemies)==0:
            Boss()
        

    screen.fill(0)

    player.behave()
    player.draw()

    for shot in shots:
        shot.behave()
        shot.draw()

    for enemy in enemies:
        enemy.behave()
        enemy.draw()

    for enemyShot in enemyShots:
        enemyShot.behave()
        enemyShot.draw()

    pygame.display.flip()

if result==True:
    print "Congratulations! You win!"
else:
    print "Your ship has been torn into thousand pieces. They couldn't even recover a body for the funeral."
